/*
 * Kinematics.cpp
 *
 *  Created on: 17 NOV 2016
 *      Author: Roman Ryutin
 */

#include <cmath>
#include <complex>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <map>
#include <string>
#include <utility>
#include <vector>
#include <stdio.h>
#include <cassert>

#include "../inc/I.h"
#include "../inc/PI.h"
#include "../inc/Particle.h"
#include "../inc/Constants.h"
#include "../inc/Kinematics.h"

// functions of class KinCM ===========================================
// here and everywhere t variables mean abs(t)!!!
// empty constructor
/*
ExDiff::KinCM::KinCM():
 particles(PInit0()),
 variables(Zero()),
 sqs(13000.0),
 t(0.0), 
 phi(0.0), 
 theta(0.0),
 y(0.0),
 DeltaT(0.0), 
 Delta3D(0.0),
 t_1(0.0), 
 t_2(0.0), 
 phi_12(0.0), 
 phi_1(0.0), 
 xi_1(0.0), 
 xi_2(0.0), 
 y_c(0.0), 
 M_T(0.0), 
 M_c(0.0), 
 DeltaT_1(0.0), 
 DeltaT_2(0.0), 
 Delta3D_1(0.0), 
 Delta3D_2(0.0),
 t_hat(0.0), 
 s_hat(0.0), 
 Eta_j(0.0), 
 Theta_j(0.0), 
 Phi_j(0.0),
 hadron1(Hadron1(13000.0)),
 hadron2(Hadron2(13000.0)),
 Delta(Zero()),
 Delta_1(Zero()),
 Delta_2(Zero())
{
	assert(!particles.empty());
    assert(!variables.empty());	
};
*/
// other constructors
/*
ExDiff::KinCM::KinCM(const double& sqs_, const std::vector<ExDiff::Particle>& particles_):
 particles(particles_),
 variables(Zero()),
 sqs(sqs_),
 t(0.0), 
 phi(0.0), 
 theta(0.0),
 y(0.0),
 DeltaT(0.0), 
 Delta3D(0.0),
 t_1(0.0), 
 t_2(0.0), 
 phi_12(0.0), 
 phi_1(0.0), 
 xi_1(0.0), 
 xi_2(0.0), 
 y_c(0.0), 
 M_T(0.0), 
 M_c(0.0), 
 DeltaT_1(0.0), 
 DeltaT_2(0.0), 
 Delta3D_1(0.0), 
 Delta3D_2(0.0),
 t_hat(0.0), 
 s_hat(0.0), 
 Eta_j(0.0), 
 Theta_j(0.0), 
 Phi_j(0.0),
 hadron1(Hadron1(sqs_)),
 hadron2(Hadron2(sqs_)),
 Delta(Zero()),
 Delta_1(Zero()),
 Delta_2(Zero())
{
	assert(!particles.empty());
	
	if(particles.size() < 2 || particles.size() > 4){
		std::cout<< "It is not possible to define 2 to 2 or 3 or 4 kinematics, number of particles are irrelevant!" <<std::endl;	
	} else {
             if(Phys() == 0){        	
	           if(particles.size() == 2){
	 	         PtoV2();
	           }
	           if(particles.size() == 3 ){
  	           	 PtoV3();
	           }	
	           if(particles.size() == 4){
	 	         PtoV4();
	           }		
	         } else {
				 std::cout<< "Physical region is impossible!" <<std::endl;
				 if(Phys() == 2){
					std::cout<< "Some particles are off-shell!" <<std::endl; 
				 }
			   } 
	  }
	
};
*/
// alternative constructor
// ID_ - different sets of variables
/*
ExDiff::KinCM::KinCM(const double& sqs_, const std::size_t& ID_, const std::vector<double>& variables_, const std::vector<double>& masses_, const std::vector<int>& IDs_):
 particles(PInit()),
 variables(variables_),
 sqs(sqs_),
 t(0.0), 
 phi(0.0), 
 theta(0.0),
 y(0.0),
 DeltaT(0.0), 
 Delta3D(0.0),
 t_1(0.0), 
 t_2(0.0), 
 phi_12(0.0), 
 phi_1(0.0), 
 xi_1(0.0), 
 xi_2(0.0), 
 y_c(0.0), 
 M_T(0.0), 
 M_c(0.0), 
 DeltaT_1(0.0), 
 DeltaT_2(0.0), 
 Delta3D_1(0.0), 
 Delta3D_2(0.0),
 t_hat(0.0), 
 s_hat(0.0), 
 Eta_j(0.0), 
 Theta_j(0.0), 
 Phi_j(0.0),
 hadron1(Hadron1(sqs_)),
 hadron2(Hadron2(sqs_)),
 Delta(Zero()),
 Delta_1(Zero()),
 Delta_2(Zero()) 
{
	assert(!variables.empty());
// define particles	
	if(masses_.size() < 2 || masses_.size() > 4){
		std::cout<< "It is not possible to define 2 to 2 or 3 or 4 kinematics, number of particles are irrelevant!" <<std::endl;	
	} else {	
	         if(masses_.size() == 2){
	 	      VtoP2(ID_,masses_,IDs_);
	         }
	         if(masses_.size() == 3){
  	  	      VtoP3(ID_,masses_,IDs_);
	         }	
	         if(masses_.size() == 4){
	 	      VtoP4(ID_,masses_,IDs_);
	         }		
	  }
	  
	  if(Phys() != 0){
	    std::cout<< "Physical region is impossible! Check out values of variables!" <<std::endl;	 
				 if(Phys() == 2){
					std::cout<< "Some particles are off-shell!" <<std::endl; 
				 }		
	  }
		
};
*/
//
/*
ExDiff::KinCM::~KinCM(){
	
};
*/
// print information
void ExDiff::KinCM::Print(){
	std::cout<< " ============================================= " <<std::endl;
	printf("p_initial[ 1 ] = { %.6f , %.6f , %.6f , %.6f }\n", hadron1._p()[0], hadron1._p()[1], hadron1._p()[2], hadron1._p()[3]);
	printf("p_initial[ 2 ] = { %.6f , %.6f , %.6f , %.6f }\n", hadron2._p()[0], hadron2._p()[1], hadron2._p()[2], hadron2._p()[3]);	
//	std::cout<< "p_initial[1] = {" << hadron1._p()[0] << " , " << hadron1._p()[1] << " , " << hadron1._p()[2] << " , " << hadron1._p()[3] << " } " <<std::endl;
//	std::cout<< "p_initial[2] = {" << hadron2._p()[0] << " , " << hadron2._p()[1] << " , " << hadron2._p()[2] << " , " << hadron2._p()[3] << " } " <<std::endl;	  
	if(particles.size() == 2){
 	 std::cout<< "Kinematical variables for 2 to 2 process" <<std::endl;
     printf("t = %.8f, theta = %.9f, y = %.9f \n", t, theta, y);	 
     printf("phi = %.6f, DeltaT = %.6f, Delta3D = %.6f \n", phi, DeltaT, Delta3D);	 
//     std::cout<< "t = " << t <<std::endl;
//     std::cout<< "theta = " << theta <<std::endl;
//     std::cout<< "y = " << y <<std::endl;	
//     std::cout<< "phi = " << phi <<std::endl; 
//     std::cout<< "DeltaT = " << DeltaT <<std::endl;
//     std::cout<< "Delta3D = " << Delta3D <<std::endl;	
	 printf("Delta = { %.6f , %.6f , %.6f , %.6f }\n", Delta[0], Delta[1], Delta[2], Delta[3]);
//     std::cout<< "Delta = {" << Delta[0] << " , " << Delta[1] << " , " << Delta[2] << " , " << Delta[3] << " } " <<std::endl;
     for(std::size_t i = 0; i < 2; i++){
	  printf("p_final[ %1i ] = { %.6f , %.6f , %.6f , %.6f }\n", i, particles[i]._p()[0], particles[i]._p()[1], particles[i]._p()[2], particles[i]._p()[3]); 
//	  std::cout<< "p_final[ " << i << " ] = {" << particles[i]._p()[0] << " , " << particles[i]._p()[1] << " , " << particles[i]._p()[2] << " , " << particles[i]._p()[3] << " } " <<std::endl;
	 } 	
 
    }
	if(particles.size() == 3 || particles.size() == 4){
	 if(particles.size() == 3){
	  std::cout<< "Kinematical variables for 2 to 3 process" <<std::endl;	
     } 	 
	 if(particles.size() == 4){
	  std::cout<< "Kinematical variables for 2 to 4 processe" <<std::endl;	
     } 	 
     printf("t1 = %.6f, t2 = %.6f, DeltaT_1 = %.6f, DeltaT_2 = %.6f \n", t_1, t_2, DeltaT_1, DeltaT_2);	
     printf("phi_12 = %.6f, phi_1 = %.6f, xi_1 = %.6f, xi_2 = %.6f \n", phi_12, phi_1, xi_1, xi_2);
     printf("y_c = %.6f, M_c = %.6f, M_T = %.6f \n", y_c, M_c, M_T);			 
//     std::cout<< "t1 = " << t_1 <<std::endl;
//     std::cout<< "t2 = " << t_2 <<std::endl;
//     std::cout<< "DeltaT_1 = " << DeltaT_1 <<std::endl;
//     std::cout<< "DeltaT_2 = " << DeltaT_2 <<std::endl;
//     std::cout<< "phi_12 = " << phi_12 <<std::endl;
//     std::cout<< "phi_1 = " << phi_1 <<std::endl;
//     std::cout<< "xi_1 = " << xi_1 <<std::endl;
//     std::cout<< "xi_2 = " << xi_2 <<std::endl;
//     std::cout<< "y_c = " << y_c <<std::endl;
//     std::cout<< "M_c = " << M_c <<std::endl;	
//     std::cout<< "M_T = " << M_T <<std::endl;	
	 printf("Delta_1 = { %.6f , %.6f , %.6f , %.6f }\n", Delta_1[0], Delta_1[1], Delta_1[2], Delta_1[3]);
	 printf("Delta_2 = { %.6f , %.6f , %.6f , %.6f }\n", Delta_2[0], Delta_2[1], Delta_2[2], Delta_2[3]);	 
//     std::cout<< "Delta_1 = {" << Delta_1[0] << " , " << Delta_1[1] << " , " << Delta_1[2] << " , " << Delta_1[3] << " } " <<std::endl;
//     std::cout<< "Delta_2 = {" << Delta_2[0] << " , " << Delta_2[1] << " , " << Delta_2[2] << " , " << Delta_2[3] << " } " <<std::endl;	 
     for(std::size_t i = 0; i < particles.size(); i++){
	  printf("p_final[ %1i ] = { %.6f , %.6f , %.6f , %.6f }\n", i, particles[i]._p()[0], particles[i]._p()[1], particles[i]._p()[2], particles[i]._p()[3]);		 
//	  std::cout<< "p_final[ " << i << " ] = {" << particles[i]._p()[0] << " , " << particles[i]._p()[1] << " , " << particles[i]._p()[2] << " , " << particles[i]._p()[3] << " } " <<std::endl;
	 } 		 	 
    }
	if(particles.size() == 4){
//	 std::cout<< "Additional kinematical variables for 2 to 4 process" <<std::endl;		
     printf("Eta_j = %.6f, Theta_j = %.6f, Phi_j = %.6f \n", Eta_j, Theta_j, Phi_j);	
	 printf("s_hat = %.6f, t_hat = %.6f \n", s_hat, t_hat);
//     std::cout<< "Eta_j = " << Eta_j <<std::endl;	
//     std::cout<< "Theta_j = " << Theta_j <<std::endl;
//     std::cout<< "Phi_j = " << Phi_j <<std::endl;     	 
    }		
	std::cout<< " ============================================= " <<std::endl;
	return;
};
// initialization of all variables and vectors 
//////////////////////////////
void ExDiff::KinCM::VtoP2(std::size_t& _ID, std::vector<double>& _masses, std::vector<int>& _IDs){
    double beta = sqrt(1.0-4.0*_masses[0]*_masses[0]/sqs/sqs);
    phi = variables[1];
	Delta[0] = 0.0;	
// classical variables = {|t|,phi}		
	if(_ID == 0){
	   t = variables[0];	
       theta = acos(1.0 - 2.0*t/sqs/sqs/beta/beta);
	   DeltaT = sqrt(t*(1.0-t/sqs/sqs/beta/beta));		   
	}		
// variables = {theta of the final hadron, phi}	
	if(_ID == 1){
	   theta = variables[0];	
	   t = 0.5*sqs*sqs*beta*beta*(1.0-cos(theta));
       DeltaT = sqrt(t*(1.0-t/sqs/sqs/beta/beta));		   
	}
// variables = {rapidity of the final hadron, phi}	
	if(_ID == 2){
	   y = variables[0]; 	
	   t = 0.5*sqs*sqs*beta*(beta-tanh(y));
       theta = acos(1.0 - 2.0*t/sqs/sqs/beta/beta); 
       DeltaT = sqrt(t*(1.0-t/sqs/sqs/beta/beta));		   
	}	
// variables = {DeltaT, phi}	
	if(_ID == 3){
	   DeltaT = variables[0];	
	   t = 0.5*sqs*sqs*beta*beta*(1.0-sqrt(1.0-4.0*DeltaT*DeltaT/sqs/sqs/beta/beta));		   
	}	
    Delta[3] = t/sqs/beta;
	Delta3D = sqrt(t);
	Delta[1] = DeltaT * cos(phi);
	Delta[2] = DeltaT * sin(phi);

    std::vector<double> p1 = hadron1.Lminus(hadron1._p(),Delta);
	p1[0] = sqrt(_masses[0]*_masses[0]+p1[1]*p1[1]+p1[2]*p1[2]+p1[3]*p1[3]);
    std::vector<double> p2 = hadron2.Lplus(hadron2._p(),Delta);
	p2[0] = sqrt(_masses[1]*_masses[1]+p2[1]*p2[1]+p2[2]*p2[2]+p2[3]*p2[3]);	
	
	ExDiff::Particle fin0(p1,_masses[0],_IDs[0],hadron1._DSpin(),hadron1._Colour(),hadron1._Anticolour());
	ExDiff::Particle fin1(p2,_masses[1],_IDs[1],hadron2._DSpin(),hadron2._Colour(),hadron2._Anticolour());	
	
    particles[0] = fin0;
    particles[1] = fin1;	    	
	
	t = -hadron1.Lmult(Delta,Delta);
	y = 0.5 * log((particles[0]._E()+particles[0]._pz())/(particles[0]._E()-particles[0]._pz()));	
	theta = acos(particles[0]._pz()/particles[0]._p3D());
	
	PtoV2();
	return;

};
//////////////////////////////
void ExDiff::KinCM::VtoP3(std::size_t& _ID, std::vector<double>& _masses, std::vector<int>& _IDs){
     
	 while(particles.size() < 3){
   	   particles.push_back(particles[1]);
	 } 

	double m = _masses[0];
    double beta = sqrt(1.0-4.0*m*m/sqs/sqs);
	phi_12 = variables[2]; 
	phi_1 = variables[4];
	M_c = _masses[1];
// variables = {DeltaT_1,DeltaT_2,phi_12,log(xi_1),phi_1}
	if(_ID == 0){
	  DeltaT_1 = variables[0];
      DeltaT_2 = variables[1];	  
	  xi_1 = exp(variables[3]);
// then correct	  
	  M_T = sqrt(M_c*M_c + DeltaT_1*DeltaT_1 + DeltaT_2*DeltaT_2 + 2.0*DeltaT_1*DeltaT_2*cos(phi_12));
      xi_2 = M_T*M_T/sqs/sqs/xi_1;	  
	  y_c = 0.5*log(xi_1/xi_2);
	}
// variables = {DeltaT_1,DeltaT_2,phi_12,y_c,phi_1}	 
	if(_ID == 1){
	  DeltaT_1 = variables[0];
      DeltaT_2 = variables[1];	  
	  y_c = variables[3];
	  M_T = sqrt(M_c*M_c + DeltaT_1*DeltaT_1 + DeltaT_2*DeltaT_2 + 2.0*DeltaT_1*DeltaT_2*cos(phi_12));
      xi_1 = M_T*exp(y_c)/sqs;
// then correct	  
      xi_2 = M_T*exp(-y_c)/sqs;	  		
	}
// variables = {t_1,t_2,phi_12,y_c,phi_1}	
	if(_ID == 2){
	  t_1 =	variables[0];
	  t_2 = variables[1];
	  y_c = variables[3];
	  M_T = sqrt(M_c*M_c + t_1 + t_2 + 2.0*sqrt(t_1*t_2)*cos(phi_12));
      xi_1 = M_T*exp(y_c)/sqs;
      xi_2 = M_T*exp(-y_c)/sqs;
      double aux1 = (t_1+2.0*m*m*xi_1)/sqs;
      double aux2 = (t_2+2.0*m*m*xi_2)/sqs; 	  
      DeltaT_1 = sqrt(t_1*(1-xi_1)-xi_1*xi_1*m*m+aux1*aux1);
	  DeltaT_2 = sqrt(t_2*(1-xi_2)-xi_2*xi_2*m*m+aux2*aux2);	  
	}	
	
	Delta_1[0] = 0.5*xi_1*sqs - (DeltaT_1*DeltaT_1 + m*m*xi_1*(2.0-xi_1))/sqs/(1.0-xi_1);
    Delta_2[0] = 0.5*xi_2*sqs - (DeltaT_2*DeltaT_2 + m*m*xi_2*(2.0-xi_2))/sqs/(1.0-xi_2);
	
	Delta_1[3] = 0.5*xi_1*sqs*beta;
	Delta_2[3] = -0.5*xi_2*sqs*beta;
	
	Delta3D_1 = sqrt(DeltaT_1*DeltaT_1+Delta_1[3]*Delta_1[3]);
	Delta3D_2 = sqrt(DeltaT_2*DeltaT_2+Delta_2[3]*Delta_2[3]);
	
	Delta_1[1] = DeltaT_1 * cos(phi_1);
	Delta_1[2] = DeltaT_1 * sin(phi_1);	
	Delta_2[1] = DeltaT_2 * cos(phi_12+phi_1);
	Delta_2[2] = DeltaT_2 * sin(phi_12+phi_1);
	
	std::vector<double> pc = hadron1.Lplus(Delta_1,Delta_2);

    t_1 = -hadron1.Lmult(Delta_1,Delta_1);
	t_2 = -hadron1.Lmult(Delta_2,Delta_2);

// corrections to on-shell : part 2	
// first final hadron	
    std::vector<double> p1_cor = hadron1.Lminus(hadron1._p(),Delta_1); 
    p1_cor[0] = sqrt(m*m+p1_cor[1]*p1_cor[1]+p1_cor[2]*p1_cor[2]+p1_cor[3]*p1_cor[3]);
    std::vector<double> p2_cor = hadron2.Lminus(hadron2._p(),Delta_2); 
 
// other particles
// aux variables 
// solve equations to correct! find p2_cor[0], p2_cor[3] !
// p2_cor[0]^2-p2_cor[3]^2=_masses[0]^2+p2_cor[1]^2+p2_cor[2]^2     
// (sqs-p1_cor[0]-p2_cor[0])^2-(p1_cor[3]+p2_cor[3])^2=_masses[1]^2+(p1_cor[1]+p2_cor[1])^2+(p1_cor[2]+p2_cor[2])^2	
    double A = - p1_cor[3]/(sqs-p1_cor[0]);
    double B = (sqs*sqs-2.0*sqs*p1_cor[0]+2.0*m*m-M_c*M_c-2.0*(p1_cor[1]*p2_cor[1]+p1_cor[2]*p2_cor[2]))*0.5/(sqs-p1_cor[0]);
    double KOR = sqrt(A*B*A*B+(1.0-A*A)*(B*B-m*m-p2_cor[1]*p2_cor[1]-p2_cor[2]*p2_cor[2]));
	if(A*B*A*B+(1.0-A*A)*(B*B-m*m-p2_cor[1]*p2_cor[1]-p2_cor[2]*p2_cor[2]) < 0.0){
		flag = 2;
	 }
// other root (A * B + KOR)/(1.0-A*A) check!
    p2_cor[3] = (A * B - KOR)/(1.0-A*A);
    p2_cor[0] = A * p2_cor[3] + B;	

    std::vector<double> pc_cor = {sqs-p1_cor[0]-p2_cor[0],-p1_cor[1]-p2_cor[1],-p1_cor[2]-p2_cor[2],-p1_cor[3]-p2_cor[3]};
 		
// all particles with corrected momenta
	ExDiff::Particle fin0(p1_cor,_masses[0],_IDs[0],hadron1._DSpin(),hadron1._Colour(),hadron1._Anticolour());
	ExDiff::Particle fin2(p2_cor,_masses[2],_IDs[2],hadron2._DSpin(),hadron2._Colour(),hadron2._Anticolour());
// scalar by default, spin can be changed manually
	ExDiff::Particle fin1(pc_cor,_masses[1],_IDs[1],1,0,0); 
 
	particles[0] = fin0;
	particles[1] = fin1;
	particles[2] = fin2;
	
//	std::cout << "!!!!!!!!!!!!!!!!!!!!!!  particles size in VtoP3 = " << particles.size() << std::endl;

// call P to V to correct variables
    PtoV3();
	return;
	
};
//////////////////////////////
void ExDiff::KinCM::VtoP4(std::size_t& _ID, std::vector<double>& _masses, std::vector<int>& _IDs){

	 while(particles.size() < 4){
   	   particles.push_back(particles[1]);
	 } 

	double m = _masses[0];
    double beta = sqrt(1.0-4.0*m*m/sqs/sqs);
	DeltaT_1 = variables[0];
	DeltaT_2 = variables[1];
	phi_12 = variables[2]; 
	phi_1 = variables[3];
    Eta_j = variables[6];
	Phi_j = variables[7];
	
//    printf("V to P: Eta_j = %.6f, Theta_j = %.6f, Phi_j = %.6f\n", Eta_j, Theta_j, Phi_j);
// variables = {DeltaT_1,DeltaT_2,phi_12,phi_1,M_c,y_c; Eta_j, Phi_j}	
	if(_ID == 0){
	 M_c = variables[4];
     y_c = variables[5];
	 M_T = sqrt(M_c*M_c + DeltaT_1*DeltaT_1 + DeltaT_2*DeltaT_2 + 2.0*DeltaT_1*DeltaT_2*cos(phi_12));
     xi_1 = M_T*exp(y_c)/sqs;
     xi_2 = M_T*exp(-y_c)/sqs;	 
	}
// variables = {DeltaT_1,DeltaT_2,phi_12,phi_1,xi_1,xi_2; Eta_j, Phi_j}		
	if(_ID == 1){
	 xi_1 = variables[4];
     xi_2 = variables[5];
     y_c = 0.5*log(xi_1/xi_2);
	 M_T = sqrt(xi_1*xi_2*sqs*sqs);
	 M_c = sqrt(M_T*M_T - DeltaT_1*DeltaT_1 - DeltaT_2*DeltaT_2 - 2.0*DeltaT_1*DeltaT_2*cos(phi_12));     	 
	}

	Delta_1[0] = 0.5*xi_1*sqs - (DeltaT_1*DeltaT_1 + m*m*xi_1*(2.0-xi_1))/sqs/(1.0-xi_1);
    Delta_2[0] = 0.5*xi_2*sqs - (DeltaT_2*DeltaT_2 + m*m*xi_2*(2.0-xi_2))/sqs/(1.0-xi_2);
	
	Delta_1[3] = 0.5*xi_1*sqs*beta;
	Delta_2[3] = -0.5*xi_2*sqs*beta;
	
	Delta3D_1 = sqrt(DeltaT_1*DeltaT_1+Delta_1[3]*Delta_1[3]);
	Delta3D_2 = sqrt(DeltaT_2*DeltaT_2+Delta_2[3]*Delta_2[3]);
	
	Delta_1[1] = DeltaT_1 * cos(phi_1);
	Delta_1[2] = DeltaT_1 * sin(phi_1);	
	Delta_2[1] = DeltaT_2 * cos(phi_12+phi_1);
	Delta_2[2] = DeltaT_2 * sin(phi_12+phi_1);
	
	std::vector<double> pc = hadron1.Lplus(Delta_1,Delta_2);

    t_1 = -hadron1.Lmult(Delta_1,Delta_1);
	t_2 = -hadron1.Lmult(Delta_2,Delta_2);	

// corrections to on-shell : part 2	
// first final hadron	
    std::vector<double> p1_cor = hadron1.Lminus(hadron1._p(),Delta_1); 
	p1_cor[0] = sqrt(m*m+p1_cor[1]*p1_cor[1]+p1_cor[2]*p1_cor[2]+p1_cor[3]*p1_cor[3]);	
    std::vector<double> p2_cor = hadron2.Lminus(hadron2._p(),Delta_2); 

// other particles
// aux variables
// solve equations to correct! find p2_cor[0], p2_cor[3] !
// p2_cor[0]^2-p2_cor[3]^2=_masses[0]^2+p2_cor[1]^2+p2_cor[2]^2     
// (sqs-p1_cor[0]-p2_cor[0])^2-(p1_cor[3]+p2_cor[3])^2=_masses[1]^2+(p1_cor[1]+p2_cor[1])^2+(p1_cor[2]+p2_cor[2])^2	
    double A = - p1_cor[3]/(sqs-p1_cor[0]);
    double B = (sqs*sqs-2.0*sqs*p1_cor[0]+2.0*m*m-M_c*M_c-2.0*(p1_cor[1]*p2_cor[1]+p1_cor[2]*p2_cor[2]))*0.5/(sqs-p1_cor[0]);
    double KOR = sqrt(A*B*A*B+(1.0-A*A)*(B*B-m*m-p2_cor[1]*p2_cor[1]-p2_cor[2]*p2_cor[2]));
	if(A*B*A*B+(1.0-A*A)*(B*B-m*m-p2_cor[1]*p2_cor[1]-p2_cor[2]*p2_cor[2]) < 0.0){
		flag = 2;
	}
// other root (A * B + KOR)/(1.0-A*A) check!
    p2_cor[3] = (A * B - KOR)/(1.0-A*A);
    p2_cor[0] = A * p2_cor[3] + B;	
	
	Delta_1 = hadron1.Lminus(hadron1._p(),p1_cor);
	Delta_2 = hadron2.Lminus(hadron2._p(),p2_cor);

    std::vector<double> pc_cor = {sqs-p1_cor[0]-p2_cor[0],-p1_cor[1]-p2_cor[1],-p1_cor[2]-p2_cor[2],-p1_cor[3]-p2_cor[3]};
	M_c = sqrt(hadron1.Lmult(pc_cor,pc_cor));
	
	ExDiff::Particle fin0(p1_cor,_masses[0],_IDs[0],hadron1._DSpin(),hadron1._Colour(),hadron1._Anticolour());
	ExDiff::Particle fin3(p2_cor,_masses[3],_IDs[3],hadron2._DSpin(),hadron2._Colour(),hadron2._Anticolour());
	particles[0] = fin0;
	particles[3] = fin3;	
	    	
// definition of other variables for central subsystem
    double kT = sqrt(0.25*M_c*M_c/cosh(Eta_j)/cosh(Eta_j)-_masses[1]*_masses[1]);
	if(0.25*M_c*M_c/cosh(Eta_j)/cosh(Eta_j)-_masses[1]*_masses[1] < 0.0){
		flag = 3 ; 
	}
	double kz = 0.5*M_c*tanh(Eta_j);
    std::vector<double> k = {0.5*M_c,kT*cos(Phi_j),kT*sin(Phi_j),kz};
	Theta_j = acos(kz/sqrt(kz*kz+kT*kT));
// transform k to CMpp

    std::vector<double> k_1 = Transform_CMdd_to_CMpp(k);
//................. 
//    printf("V to P k in C.M. dd = { %.6f, %.6f, %.6f %.6f }\n", k[0], k[1], k[2], k[3]);	
//    printf("V to P k_1 in C.M. pp = { %.6f, %.6f, %.6f %.6f }\n", k_1[0], k_1[1], k_1[2], k_1[3]);	
//    std::vector<double> k_dd = Transform_CMdd_to_CMpp(k_1);
//    printf("from transformation k =? k_dd = { %.6f, %.6f, %.6f %.6f }\n", k_dd[0], k_dd[1], k_dd[2], k_dd[3]);	
//    std::vector<double> k_pp = Transform_CMpp_to_CMdd(k_dd);
//    printf("from transformation k_1 =? k_pp = { %.6f, %.6f, %.6f %.6f }\n", k_pp[0], k_pp[1], k_pp[2], k_pp[3]);	
		
// corrections to mass-shell k_1, k_2  
    A = pc_cor[3]/pc_cor[0]; 
	B = (M_c*M_c+_masses[1]*_masses[1]-_masses[2]*_masses[2]+2.0*(pc_cor[1]*k_1[1]+pc_cor[2]*k_1[2]))*0.5/pc_cor[0];
	KOR = sqrt(A*A*B*B+(1.0-A*A)*(B*B-_masses[1]*_masses[1]-k_1[1]*k_1[1]-k_1[2]*k_1[2]));
	if(A*A*B*B+(1.0-A*A)*(B*B-_masses[1]*_masses[1]-k_1[1]*k_1[1]-k_1[2]*k_1[2]) < 0.0){
		flag = 2;
	}
// choose root!!!!!!!!!!!!!!!!!! how????
	k_1[3] = (A*B+copysign(KOR,A*B))/(1.0-A*A);
//	printf("A = %.6f , root1 = %.6f , root2 = %.6f\n", A, (A*B+KOR)/(1.0-A*A), (A*B-KOR)/(1.0-A*A));
	
	k_1[0] = A*k_1[3]+B;
//.................
//   printf("VP calc A = %.6f, B = %.6f, KOR2 = %.6f\n", A, B, A*A*B*B+(1.0-A*A)*(B*B-_masses[1]*_masses[1]-k_1[1]*k_1[1]-k_1[2]*k_1[2]));		
//.................
//    printf("V to P calc equations k_1 = { %.6f, %.6f, %.6f %.6f }\n", k_1[0], k_1[1], k_1[2], k_1[3]);		
	
	std::vector<double> k_2 = hadron1.Lminus(pc_cor,k_1);	
	
// sub-variables    	
    std::vector<double> v_t_hat = hadron1.Lminus(Delta_1,k_1);
    s_hat = M_c*M_c; 
    t_hat = -hadron1.Lmult(v_t_hat,v_t_hat);
////////////////////////////////////////////////////////////	
   		
// scalars by default, can be changed manually	
	ExDiff::Particle fin1(k_1,_masses[1],_IDs[1],1,0,0);
	ExDiff::Particle fin2(k_2,_masses[2],_IDs[2],1,0,0);	
	
	particles[1] = fin1;
	particles[2] = fin2;

    PtoV4();	
	return;
};
/////////////////////////////////////////////////////
// t variables everywhere means abs(t)   
// initializations, if we know all particles momenta
void ExDiff::KinCM::PtoV2(){
	Delta = hadron1.Lminus(hadron1._p(),particles[0]._p());
	t = -hadron1.Lmult(Delta,Delta);
	double m = particles[0]._m();
	double beta = sqrt(1.0-4.0*m*m/sqs/sqs);
//	theta = acos(1-2.0*t/sqs/sqs/beta/beta);
	y = 0.5 * log((particles[0]._E()+particles[0]._pz())/(particles[0]._E()-particles[0]._pz()));	
	theta = acos(particles[0]._pz()/particles[0]._p3D());
    if(-particles[0]._py() >=0){	
	 phi = acos(-particles[0]._px()/particles[0]._pT());
    } else {
	 phi = 2.0*PI - acos(-particles[0]._px()/particles[0]._pT());	
	}
	DeltaT = particles[0]._pT();
	Delta3D = sqrt(Delta[1]*Delta[1]+Delta[2]*Delta[2]+Delta[3]*Delta[3]);

// variables by default	ID=0, {t,phi}
	variables.clear();
	variables.push_back(t);
	variables.push_back(phi);
	
	return;
};

void ExDiff::KinCM::PtoV3(){
	Delta_1 = hadron1.Lminus(hadron1._p(),particles[0]._p());
	Delta_2 = hadron2.Lminus(hadron2._p(),particles[2]._p());
	t_1 = -hadron1.Lmult(Delta_1,Delta_1);	
	t_2 = -hadron2.Lmult(Delta_2,Delta_2);
	if(-particles[0]._py() >= 0){
     phi_1 = acos(-particles[0]._px()/particles[0]._pT());
    } else {
	 phi_1 = 2.0*PI - acos(-particles[0]._px()/particles[0]._pT());	
	}	
	phi_12 = acos((Delta_1[1]*Delta_2[1]+Delta_1[2]*Delta_2[2])/particles[0]._pT()/particles[2]._pT());

//	printf("P to V phi_12 = %.6f\n",phi_12);
	
	xi_1 = Delta_1[3]/hadron1._pz();
	xi_2 = Delta_2[3]/hadron2._pz();
	y_c = 0.5*log(xi_1/xi_2);
	M_c = particles[1]._m();
	DeltaT_1 = particles[0]._pT(); 
	DeltaT_2 = particles[2]._pT();
	Delta3D_1 = sqrt(Delta_1[1]*Delta_1[1]+Delta_1[2]*Delta_1[2]+Delta_1[3]*Delta_1[3]);
	Delta3D_2 = sqrt(Delta_2[1]*Delta_2[1]+Delta_2[2]*Delta_2[2]+Delta_2[3]*Delta_2[3]);
// approx. formula for sqrt(s*xi_1*xi_2)		
	M_T = sqrt(M_c*M_c + DeltaT_1*DeltaT_1+DeltaT_2*DeltaT_2+2.0*DeltaT_1*DeltaT_2*cos(phi_12));

// variables by default	ID=2
	variables.clear();
	variables.push_back(DeltaT_1);
	variables.push_back(DeltaT_2);
	variables.push_back(phi_12);
	variables.push_back(y_c);
	variables.push_back(phi_1);	
	
	return;
};

void ExDiff::KinCM::PtoV4(){
	Delta_1 = hadron1.Lminus(hadron1._p(),particles[0]._p());
	Delta_2 = hadron2.Lminus(hadron2._p(),particles[3]._p());
	std::vector<double> pc = hadron1.Lplus(particles[1]._p(),particles[2]._p());
	
//	particles[1].Print();
//	particles[2].Print();
	
	t_1 = -hadron1.Lmult(Delta_1,Delta_1);	
	t_2 = -hadron2.Lmult(Delta_2,Delta_2);
	if(-particles[0]._py() >= 0){
     phi_1 = acos(-particles[0]._px()/particles[0]._pT());
    } else {
	 phi_1 = 2.0*PI - acos(-particles[0]._px()/particles[0]._pT());	
	}		
	phi_12 = acos((Delta_1[1]*Delta_2[1]+Delta_1[2]*Delta_2[2])/particles[0]._pT()/particles[3]._pT());
	xi_1 = Delta_1[3]/hadron1._pz();
	xi_2 = Delta_2[3]/hadron2._pz();
	y_c = 0.5*log(xi_1/xi_2);
	
	std::vector<double> p_c = hadron1.Lplus(Delta_1,Delta_2);
// central mass is not a constant as in 2 to 3 process	
	M_c = sqrt(std::abs(hadron1.Lmult(p_c,p_c)));
// ........................
//    printf("M_c PtoV = %.6f\n", M_c);	
	
	DeltaT_1 = particles[0]._pT(); 
	DeltaT_2 = particles[3]._pT();
	Delta3D_1 = sqrt(Delta_1[1]*Delta_1[1]+Delta_1[2]*Delta_1[2]+Delta_1[3]*Delta_1[3]);
	Delta3D_2 = sqrt(Delta_2[1]*Delta_2[1]+Delta_2[2]*Delta_2[2]+Delta_2[3]*Delta_2[3]);
// approx. formula for sqrt(s*xi_1*xi_2)	
	M_T = sqrt(M_c*M_c + DeltaT_1*DeltaT_1+DeltaT_2*DeltaT_2+2.0*DeltaT_1*DeltaT_2*cos(phi_12));		
// hat variables
    std::vector<double> v_t_hat = hadron1.Lminus(Delta_1,particles[1]._p());
   	t_hat = -hadron1.Lmult(v_t_hat,v_t_hat);
	s_hat = M_c * M_c;
// C.M. of particles 1 and 2 subsystem

//.............
//    printf("P to V before: Eta_j = %.6f, Theta_j = %.6f, Phi_j = %.6f\n", Eta_j, Theta_j, Phi_j);	
//    printf("momentum k_1 and k_2 C.M. pp before = \n");
//	hadron1.Lprint(particles[1]._p());	
//	hadron1.Lprint(particles[2]._p());
	
    std::vector<double> k_1_CMdd = Transform_CMpp_to_CMdd(particles[1]._p());

//	printf("momentum k_1 and k_2 C.M. pp = \n");
//	hadron1.Lprint(particles[1]._p());	
//	hadron1.Lprint(particles[2]._p());
//	printf("momentum k_1 C.M. dd = \n");
//	hadron1.Lprint(k_1_CMdd);
	
	Eta_j = 0.5 * log((k_1_CMdd[0]+k_1_CMdd[3])/(k_1_CMdd[0]-k_1_CMdd[3]));
	Theta_j = acos(k_1_CMdd[3]/sqrt(k_1_CMdd[1]*k_1_CMdd[1]+k_1_CMdd[2]*k_1_CMdd[2]+k_1_CMdd[3]*k_1_CMdd[3]));
    if(k_1_CMdd[2] >= 0.0){
		Phi_j = acos(k_1_CMdd[1]/sqrt(k_1_CMdd[1]*k_1_CMdd[1]+k_1_CMdd[2]*k_1_CMdd[2]));
	} else{
	    Phi_j = 2 * PI - acos(k_1_CMdd[1]/sqrt(k_1_CMdd[1]*k_1_CMdd[1]+k_1_CMdd[2]*k_1_CMdd[2]));
	}
	
//.............
//    printf("P to V: Eta_j = %.6f, Theta_j = %.6f, Phi_j = %.6f\n", Eta_j, Theta_j, Phi_j);	
	
// variables by default	ID=0
	variables.clear();
	variables.push_back(DeltaT_1);
	variables.push_back(DeltaT_2);
	variables.push_back(phi_12);
    variables.push_back(phi_1);	
	variables.push_back(M_c);	
	variables.push_back(y_c);	
    variables.push_back(Eta_j);
    variables.push_back(Phi_j);	
	
	return;
	
};
// Phys. region check and particles on-shell!
int ExDiff::KinCM::Phys(){
       
	 double eps = 1.0e-10; 
	 int n = 0;
	 double mq2, mq;
	 std::vector<double> q = particles[0]._p();
	 std::vector<double> sum = {0.0,0.0,0.0,0.0};
     for(std::size_t i = 0; i < particles.size(); i++){
		mq = particles[i]._m();
//		std::cout<< "m[" << i << "] = " << mq <<std::endl;
        q = particles[i]._p();
//        hadron1.Lprint(q);		
		mq2 = hadron1.Lmult(q,q);
//		std::cout<< "mcalc[" << i << "] = " << sqrt(mq2) <<std::endl;
		sum = hadron1.Lplus(sum,q);
		if(q[0] < -eps){
		 n = 1;	
		}		
//		particles[i].Print();
		if(particles[i].OnShell() != 0){
		 n = 2;	
		}
	 }	 
     sum = hadron1.Lminus(sum,hadron1._p());
	 sum = hadron1.Lminus(sum,hadron2._p());
	 if( std::abs(sum[0]) > eps && std::abs(sum[1]) > eps && std::abs(sum[2]) > eps && std::abs(sum[3]) > eps && n != 2){
		 n = 1;
	 }	 	 

	 if(particles.size() == 4){
    	 std::vector<double> prov = particles[0].Lplus(particles[1]._p(),particles[2]._p());
       
        if(particles[0].Lmult(prov,prov) < eps){ 
		   n = 4;
		 } else {	   
     	     double aux = sqrt(particles[0].Lmult(prov,prov)) - particles[1]._m() - particles[2]._m(); 		 
		     if(aux < -eps*eps && n != 2){
		       n = 3;
		     }
		     if(aux < -eps*eps && n == 2){
		       n = 4;
		     }	   		 
	       }
	 }	
	 
	 if(flag != 0){
		 n = 5;
	 } 
//     hadron1.Lprint(sum);  
     
	 return n;
};
// Lorentz transformations from/to proton(p1)+proton(p2) C.M. frame to/from "Pomeron"(Delta_1)+ "Pomeron"(Delta_2) C.M. frame
// for 2 to 3 and 2 to 4 processes
// transformation to C.M. Delta_1+Delta_2 from C.M. proton1+proton2 (initial frame)
std::vector<double> ExDiff::KinCM::Transform_CMpp_to_CMdd(std::vector<double>& k_){	
// k_ - vector in proton_1+proton_2 C.M. frame	(initial C.M. frame)
        double eps = 1.0e-10;
		std::vector<double> res({0.0,0.0,0.0,0.0});
		std::vector<double> pc = hadron1.Lplus(Delta_1,Delta_2);
		double _pT_c = sqrt(pc[1]*pc[1]+pc[2]*pc[2]);
		double _rho_c = sqrt(_pT_c*_pT_c+pc[3]*pc[3]);	
		double _eta = 1.0;
        if(pc[0]-_rho_c > eps){		
		  _eta = 0.5 * log((pc[0]+_rho_c)/(pc[0]-_rho_c));
		} else {
			std::cout<< "pc vector is irrelevant. Ec <= pc_3D" <<std::endl;
			flag = 1;
			 _eta = 100.0;
		  }
		double _cfi = pc[1]/_pT_c;
		double _sfi = pc[2]/_pT_c;
		double _ctheta = pc[3]/_rho_c;
		double _stheta = _pT_c/_rho_c;
        
		double aux1 = k_[1] * _cfi + k_[2] * _sfi;
		double aux2 = k_[3] * _ctheta + aux1 * _stheta;
		res[0] = k_[0] * cosh(_eta) - aux2 * sinh(_eta);
		res[3] = -k_[0] * sinh(_eta) + aux2 * cosh(_eta);
		res[1] = -k_[3] * _stheta + aux1 * _ctheta;
		res[2] = -k_[1] * _sfi + k_[2] * _cfi;
		
        return res;		
	};
// transformation from C.M. Delta_1+Delta_2 to C.M. proton1+proton2 (initial frame)
std::vector<double> ExDiff::KinCM::Transform_CMdd_to_CMpp(std::vector<double>& k_){
// k_ - vector in Delta_1+Delta_2 C.M. frame
        double eps = 1.0e-10;		
		std::vector<double> res({0.0,0.0,0.0,0.0});
		std::vector<double> pc = hadron1.Lplus(Delta_1,Delta_2);
		double _pT_c = sqrt(pc[1]*pc[1]+pc[2]*pc[2]);
		double _rho_c = sqrt(_pT_c*_pT_c+pc[3]*pc[3]);	
		double _eta = 1.0;
        if(pc[0] - _rho_c > eps){		
		  _eta = 0.5 * log((pc[0]+_rho_c)/(pc[0]-_rho_c));
		} else {
			std::cout<< "pc vector is irrelevant. Ec <= pc_3D" <<std::endl;
			flag = 1;
			 _eta = 100.0;
		  }
		double _cfi = pc[1]/_pT_c;
		double _sfi = pc[2]/_pT_c;
		double _ctheta = pc[3]/_rho_c;
		double _stheta = _pT_c/_rho_c;
        
		double aux1 = k_[0] * sinh(_eta) + k_[3] * cosh(_eta);
		double aux2 = k_[1] * _ctheta + aux1 * _stheta;
		res[0] = k_[0] * cosh(_eta) + k_[3] * sinh(_eta);
		res[3] = aux1 * _ctheta - k_[1] * _stheta;
		res[1] = aux2 * _cfi - k_[2] * _sfi;
		res[2] = aux2 * _sfi + k_[2] * _cfi;
		
        return res;								
	};
	// other version reload
	// transformation to C.M. Delta_1+Delta_2 from C.M. proton1+proton2 (initial frame)
std::vector<double> ExDiff::KinCM::Transform_CMpp_to_CMdd_(std::vector<double>& k_, std::vector<double>& Delta_1_, std::vector<double>& Delta_2_){	
// k_ - vector in proton_1+proton_2 C.M. frame	(initial C.M. frame)
        double eps = 1.0e-10;
		std::vector<double> res({0.0,0.0,0.0,0.0});
		std::vector<double> pc = hadron1.Lplus(Delta_1_,Delta_2_);
		double _pT_c = sqrt(pc[1]*pc[1]+pc[2]*pc[2]);
		double _rho_c = sqrt(_pT_c*_pT_c+pc[3]*pc[3]);	
		double _eta = 1.0;
        if(pc[0]-_rho_c > eps){		
		  _eta = 0.5 * log((pc[0]+_rho_c)/(pc[0]-_rho_c));
		} else {
			std::cout<< "pc vector is irrelevant. Ec <= pc_3D" <<std::endl;
			flag = 1;
			 _eta = 100.0;
		  }
		double _cfi = pc[1]/_pT_c;
		double _sfi = pc[2]/_pT_c;
		double _ctheta = pc[3]/_rho_c;
		double _stheta = _pT_c/_rho_c;
        
		double aux1 = k_[1] * _cfi + k_[2] * _sfi;
		double aux2 = k_[3] * _ctheta + aux1 * _stheta;
		res[0] = k_[0] * cosh(_eta) - aux2 * sinh(_eta);
		res[3] = -k_[0] * sinh(_eta) + aux2 * cosh(_eta);
		res[1] = -k_[3] * _stheta + aux1 * _ctheta;
		res[2] = -k_[1] * _sfi + k_[2] * _cfi;
		
        return res;		
	};
// transformation from C.M. Delta_1+Delta_2 to C.M. proton1+proton2 (initial frame)
std::vector<double> ExDiff::KinCM::Transform_CMdd_to_CMpp_(std::vector<double>& k_, std::vector<double>& Delta_1_, std::vector<double>& Delta_2_){
// k_ - vector in Delta_1+Delta_2 C.M. frame
        double eps = 1.0e-10;		
		std::vector<double> res({0.0,0.0,0.0,0.0});
		std::vector<double> pc = hadron1.Lplus(Delta_1_,Delta_2_);
		double _pT_c = sqrt(pc[1]*pc[1]+pc[2]*pc[2]);
		double _rho_c = sqrt(_pT_c*_pT_c+pc[3]*pc[3]);	
		double _eta = 1.0;
        if(pc[0] - _rho_c > eps){		
		  _eta = 0.5 * log((pc[0]+_rho_c)/(pc[0]-_rho_c)); 
		} else {
			std::cout<< "pc vector is irrelevant. Ec <= pc_3D" <<std::endl;
			flag = 1;
			 _eta = 100.0;
		  }
		double _cfi = pc[1]/_pT_c;
		double _sfi = pc[2]/_pT_c;
		double _ctheta = pc[3]/_rho_c;
		double _stheta = _pT_c/_rho_c;
        
		double aux1 = k_[0] * sinh(_eta) + k_[3] * cosh(_eta);
		double aux2 = k_[1] * _ctheta + aux1 * _stheta;
		res[0] = k_[0] * cosh(_eta) + k_[3] * sinh(_eta);
		res[3] = aux1 * _ctheta - k_[1] * _stheta;
		res[1] = aux2 * _cfi - k_[2] * _sfi;
		res[2] = aux2 * _sfi + k_[2] * _cfi;
		
        return res;								
	};
	
